;I realize this code is kinda sloppy, and could be optimized quite a bit, but this is my 2nd ASM game, so lay off! Hope
;this helps you, I've learned quite a bit making this game, so you might be able to too. One of my best successes (i think)
;was compressing the map info (4 bits per block!). But, by the way, YESSSS!!! I finished it!!!!!!!!!!!!!!!!

#include "ti86asm.inc"
#include "dwfight.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Dragon Warrior 86",0

ProgStart:
	call waitkey
	call _runindicoff
	call LoadGreyscale
	call ClearScreen
	ld bc, $000f
	ld de, $0106
	call makewindow
	ld hl, ShellTitle
	ld de, $0b20
	call drawstring
	ld hl, titlescreen1
	ld de, $1204
	call drawstring
	ld hl, titlescreen2
	ld de, $2305
	call drawstring
	ld hl, titlescreen3
	ld de, $2a05
	call drawstring
titleloop:
	ld b, 1
	call keyloop
	cp 6
	jr z, loadgame
	cp 0
	jr z, titleloop
	call ClearScreen
	call WalkAround
finishgame:
	call CloseGrey
	jp ClearScreen

loadgame:
	ld hl, dwsave
	call loadstring
	ld hl, $8100
	ld de, name
	ld bc, 99
	ldir
	call LoadMap
	ld hl, herospriteup1
	ld (dirword), hl
	call LoadTileMap
	call pause
	ld hl, $1304
	call gsearch4
	ld hl, 4135
	call startgame
	jr finishgame
	
WalkAround:
	ld hl, $09c6
	ld (curmap), hl
	call LoadMap
	ld hl, herospriteup1
	ld (dirword), hl
	ld hl, 4135
	ld (playerpos), hl
	call LoadTileMap
	call pause
	ld hl, $0cae
	call gsearch4
startgame:
	ld hl, herospritedown1
	ld (dirword), hl
	ld hl, 4135

WalkAround2:
	ld (playerpos), hl
	call LoadTileMap
	ld c, 3
	call checktransport
	ld b, 45													;The BIG nothing loop
	call keyloop
	ld hl, (playerpos)											;monster ambushes
	ld de, 10594
	call hlde
	cp 2
	jp z, golemfight
	ld de, 4269
	call hlde
	cp 2
	jp z, knightfight
	ld de, 4208
	call hlde
	cp 2
	jp z, dragonfight
nofight:
	ld hl, (playerpos)
	ld a, (walkvar)
	ld b, a
	ld a, 1
	sub b
	ld (walkvar), a
	ld b, 9
	ld de, (curmapwidth)										;if outside, blocked with numbers >10 (9) if not blocked by >8 (7)
	ld a, e
	cp 64
	jr z, WA2c
	ld b, 7

WA2c:
	ld c, 8
	ld de, (curmapwidth)
	ld a, e
	cp 64
	call z, LOADC10
	ld a, (keyvar)
	cp 1
	jp z, gomapdown
	cp 2
	jp z, gomapleft
	cp 3
	jp z, gomapright
	cp 4
	jp z, gomapup
	cp 6
	call z, drawselectwindow
	cp 7
	call z, contrastup
	ld a, (keyvar)
	cp 8
	call z, contrastdown
	ld a, (stillvar)
	inc a
	ld (stillvar), a
	cp 6
	call z, dswloop
	ld a, (keyvar)
	ld hl, (playerpos)
	cp 5
	jp nz, WalkAround2

LOADC10:
	ld c, 10
	ret

golemfight:
	ld a, (golemattack)
	cp 0
	jp nz, nofight
	inc a
	ld (golemattack), a
	ld b, 36
	call beginfight
	jp WalkAround2

dragonfight:
	ld a, (monster2)
	cp 1
	jp nz, nofight
	ld a, (dragonattack)
	cp 0
	jp nz, nofight
	inc a
	ld (dragonattack), a
	ld b, 22
	call beginfight
	jp WalkAround2


knightfight:
	ld a, (monster2)
	cp 9
	jp nz, nofight
	ld a, (knightattack)
	cp 0
	jp nz, nofight
	inc a
	ld (knightattack), a
	ld b, 25
	call beginfight
	jp WalkAround2

beginfight:
	push bc
	ld hl, dwfight
	call loadstring
	ld a, 1
	ld (fighton), a
	pop bc
	ld a, b
	call startfight
	xor a
	ld (fighton), a
	call loadmap
	ld hl, (playerpos)
	ret

;*************************************************************************
;* Moving Directions                                                     *
;*************************************************************************

gomapup:
	ld a, 4
	ld (lookdir), a
	ld de, herospriteup1
	ld (dirword), de
	ld a, (upblock)
	call checkmove
	jp z, WalkAround2
	ld de, (curmapwidth)
	dec de
	sbc hl, de
	ld (playerpos), hl
	jp justmovedaround

gomapdown:
	ld a, 1
	ld (lookdir), a
	ld de, herospritedown1
	ld (dirword), de
	ld a, (downblock)
	call checkmove
	jp z, WalkAround2
	ld de, (curmapwidth)
	add hl, de
	ld (playerpos), hl
	jp justmovedaround

gomapright:
	ld a, 3
	ld (lookdir), a
	ld de, herospriteright1
	ld (dirword), de
	ld a, (rightblock)
	call checkmove
	jp z, WalkAround2
	ld de, 0
	call chmapxhalfr
	add hl, de
	ld (playerpos), hl
	jp justmovedaround

chmapxhalfr:
	ld a, (mapxhalf)
	ld b, a
	ld a, 1
	sub b
	ld (mapxhalf), a
	ld e, b
	ret
	
gomapleft:
	ld a, 2
	ld (lookdir), a
	ld de, herospriteleft1
	ld (dirword), de
	ld a, (leftblock)
	call checkmove
	jp z, WalkAround2
	ld de, 0
	call chmapxhalfl
	sbc hl, de
	ld (playerpos), hl
	jr justmovedaround

chmapxhalfl:
	ld a, (mapxhalf)
	ld b, a
	ld a, 1
	sub b
	ld (mapxhalf), a
	ld e, a
	ret

checkmove:
	ld b, a
	ld a, c
	cp 8
	call z, make1
	ld a, b
	cp c
	jr nc, make0
	ld a, 1
	ret
make0:
	xor a
	ret
make1:
	ld a, b
	cp 15
	call z, make0
	ld b, a
	ret

justmovedaround:
	xor a
	ld (stillvar), a
	ld a, (repelcounter)
	cp 0
	call nz, countoff
	ld a, (armor)
	cp 30
	jp nc, goodarmor
	ld a, c
	cp 8
	jr z, checkzap
	cp 10
	jr z, checkswamp
jmaback:
	ld a, r
	cp 10
	call c, loadfight
	ld a, (radiance)
	cp 0
	call nz, countofflight
	call LoadTileMap
	ld hl, (playerpos)
	jp WalkAround2

checkzap:
	ld a, (sameblock)
	cp 15
	jr nz, jmaback
	ld a, (hp)
	sub 15
	ret c
	ret z
czback:
	ld (hp), a
	ld b, 5
	call flicker
	jr jmaback

checkswamp:
	ld a, (sameblock)
	cp 5
	jr nz, jmaback
	ld a, (hp)
	sub 1
	ret c
	ret z
	jr czback

goodarmor:
	cp 31
	jr z, goerdrick
	ld a, r
	and %00010000
	cp %00010000
	jp z, jmaback
goerdrick:
	ld a, (hp)
	ld b, a
	ld a, (maxhp)
	cp b
	jp z, jmaback
	inc b
	ld a, b
	ld (hp), a
	jp jmaback
	
loadfight:
	ld a, (monster2)
	cp 0
	ret z
	ld a, (repelcounter)
	cp 0
	ret nz
rloadfight:
	ld hl, dwfight
	call loadstring
	ld a, 1
	ld (fighton), a
	call fight
	xor a
	ld (fighton), a
	jp loadmap
countoff:
	dec a
	ld (repelcounter), a
	ret
countofflight:
	ld a, (radcounter)
	dec a
	call z, lowerlight
	ld (radcounter), a
	ret

lowerlight
	ld a, (radiance)
	dec a
	ld (radiance), a
	ld a, 150
	ret
;*************************************************************************
;* Transport Checking Stuff                                              *
;*************************************************************************

checktransport:
	ld de, (playerpos)
	ld (cpword), de
	ld a, (mapxhalf)
	ld (xhalf), a
	call cplocation
	ld a, b
	cp 0
	ret z												;if b=0 then it found nothing, else hl=location of starting byte (byte #4)
	push hl
	ld hl, (curmap)
	ld a, l
	cp 0
	call z, savepos
	pop hl
	inc hl												;load new map positions
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ld (curmap), de
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ld (playerpos), de
	inc hl
	ld a, (hl)
	ld (mapxhalf), a
	ld a, ($C008)
	ld b, a 											;fade out
	ld a, 31
	sub b
	ld b, a
	push bc
ctloop1:
	push bc
	ld b, 5
	call keyloop
	pop bc
	call contrastup
	djnz ctloop1
	call LoadMap									;draw new map info
	ld de, herospritedown1
	ld (dirword), de
	call LoadTileMap
	pop bc												;fade back in
ctloop2:
	push bc
	ld b, 5
	call keyloop
	pop bc
	call contrastdown
	djnz ctloop2
	ld hl, 0							;opened doors DO NOT save (except the one by the king)
	ld (doors), hl
	ld b, 1
	ret
savepos:
	ld hl, (playerpos)
	ld (worldpos), hl
	ld a, (mapxhalf)
	ld b, a
	ld a, 1
	sub b
	ld (wxhalf), a
	ret

;*************************************************************************
;* Map Loading                                                           *
;*************************************************************************

LoadMap:
	ld de, (curmap)
	ld a, e
	ld hl, dwmaps
	cp 0
	call nz, insidemap
	call loadstring
	ld de, (curmap)
	add hl, de
	ld a, (hl)
	ld d, 0
	ld e, a
	ld (curmapwidth), de
	inc hl
	ld a, (hl)
	ld (monster1), a
	inc hl
	ld a, (hl)
	ld (monster2), a
	inc hl
	push hl
	call _ldhlind
	ld (mapsize), hl	
	pop hl
	ld de, 2
	add hl, de
	ld (mappos), hl
	ret
insidemap:
	ld hl, dwmaps2
	ret

#include lstat.asm												;little status window
#include gselect.asm											;general selection thing
#include variable.asm											;variables (strings, etc.)
#include LTM.asm													;Load Tile Map
#include subroutes.asm										;subroutines
#include greyscale.asm										;greyscale routines
#include dwmapsprites.asm									;gfx
#include dwcharsprites.asm									;gfx

.end
